//上线前清掉console和alert
console.log = function() {};
alert = function() {};

;
(function() {
	"use strict";

	//动态兼容沉浸式状态栏
	var immersed = 0;
	var headerEl = document.querySelector('header.mui-bar-nav') || document.querySelector('.immersed-header');
	var _style;

	var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
	//	alert(navigator.userAgent);
	if (ms && ms.length >= 3) {
		immersed = parseFloat(ms[2]);
	}
	//	alert(immersed);
	window.immersed = immersed; //状态栏高度
	if (immersed) {
		if (headerEl) {
			//header长度增加和padding-top增加
			_style = document.defaultView.getComputedStyle(headerEl);
			headerEl.style.height = immersed + parseInt(_style.getPropertyValue('height')) + 'px';
			headerEl.style.paddingTop = immersed + parseInt(_style.getPropertyValue('padding-top')) + 'px';
			//header后面的元素下移
			var nextEl = headerEl.nextElementSibling;
			if (nextEl) {
				_style = document.defaultView.getComputedStyle(nextEl);
				nextEl.style.marginTop = immersed + parseInt(_style.getPropertyValue('margin-top')) + 'px';
			}
		}
	}
})();

/**
 * @description 主程序
 */
;
(function() {

	"use strict";

	var project = {
		init: function() {
			var _ = this;
			_.bindEvent();
		},
		bindEvent: function() {
			var httpHeaderEx = {};
			document.addEventListener("plusready", function() {
				httpHeaderEx = {
					//                  'x-wolf-system': sg.AppSystem().toString(),
					//                  'x-wolf-mac-address': sg.getDeviceUUID(),
					//                  'x-wolf-app-version': sg.getAppVersion(),
					//                  'x-wolf-app-type': APP_TYPE.toString(),
					//                  'x-wolf-app-from': APP_FROM.toString(),
					//                  'x-wolf-device-id': sg.SGGetDeviceCode()
				};

				//				sg.screenLockV();
				document.addEventListener('visibilitychange', function() {
					if (document.hidden)
						return;
					//  sg.screenLockH();
					setTimeout(function() {
						sg.screenLockV();
					}, 100)
				}, false);

			}, false);

			if ('addEventListener' in document) {
				document.addEventListener('DOMContentLoaded', function() {}, false);
			}

		}
	};

	//初始化
	mui.plusReady(function() {
		project.init();
	});
})();

var clickCount = 0;

function checkDoubleClick() {
	++clickCount;
	if (clickCount > 1) {
		console.debug('double click, ignore this click');
		return false;
	}

	setTimeout(function() {
		clickCount = 0;
	}, 500);
	return true;
}

// 接口域名
/** release server */
//var interfaceHost = 'http://192.168.1.250:8080/task_dispatch/app/';
//var interfaceHost = 'http://iccapp.ngrok.cc/task_dispatch/app/';
var interfaceHost = 'http://120.76.229.57/task_dispatch/app/';

//全局新窗口动画
var aniType = {
	aniShow: "pop-in",
	duration: 300
};

/**
 * onerror image (占位图片)
 */
var onErrorImg = ' onerror="this.src=\'../../images/default.png\'" ';

/**
 * @description MUI网络操作对象
 */
var httpClient = (function(mui, w) {

	var ins = new mui.Class();

	/**
	 * mui的ajax get方法封装
	 * @param {String} url（必填）
	 * @param {Object} paramter（可选）
	 * @param {Function} successCB（必填）
	 * @param {Function} errorCB（可选）
	 */
	ins.get = function(url, paramter, successCB, errorCB) {
		var mod = sg.isOfflineModel();
		var _successCB = successCB;
		var _errorCB = errorCB;
		if (mod) {
			error({
				code: -1,
				what: 'Network disconnected.'
			});
			return;
		}
		console.log('ajax get请求，url：' + url + '，位置：' + document.location.toString());
		if (paramter && typeof paramter == 'function') {
			_errorCB = successCB;
			_successCB = paramter;
			paramter = {};
		}
		mui.ajax(url, {
			type: 'get',
			dataType: 'json',
			data: paramter,
			success: function(data, status) {
				_successCB(data, status);
			},
			error: function(xhr, type, errorThrown) {
				console.error('ajax get请求出错，url：' + url + '，错误类型：' + type + '，位置：' + document.location.toString());
				if (_errorCB) {
					_errorCB(xhr, type, errorThrown);
				}
			},
			timeout: 10000
		});
	};
	/**
	 * mui的ajax post方法封装
	 * @param {String} url（必填）
	 * @param {Object} paramter（必填）
	 * @param {Function} successCB（必填）
	 * @param {Function} errorCB（可选）
	 */
	ins.post = function(url, paramter, successCB, errorCB) {
		var mod = sg.isOfflineModel();
		if (mod) {
			error({
				code: -1,
				what: 'Network disconnected.'
			});
			return;
		}
		console.log('ajax post请求，url：' + url + '，位置：' + document.location.toString());
		mui.ajax(url, {
			type: 'post',
			data: paramter,
			dataType: 'json',
			success: function(data) {
				//本项目(金盘)所有接口返回的都是字符串，所以在这里做转换再返回
				successCB(data, status);
			},
			error: function(xhr, type, errorThrown) {
				console.error('ajax post请求出错，url：' + url + '，错误类型：' + type + '，位置：' + document.location.toString());
				if (errorCB) {
					errorCB(xhr, type, errorThrown);
				}
			},
			timeout: 10000
		});
	};

	return ins;
})(mui, window);

/**
 * @description 数据库操作对象
 */
var db = (function(mui, w) {

	var ins = new mui.Class();

	/**
	 * @description 写入一个对象 Key，Value
	 */
	ins.add = function(key, value) {
		if (w.plus) {
			var val = JSON.stringify(value);
			plus.storage.setItem(key, val);
			//			CommonUtils.consoleLog('db add key: ' + key + ' value: ' + val);
		}
	}

	/**
	 * @description 获取一个对象，key
	 */
	ins.get = function(key) {
		if (w.plus) {
			var val = plus.storage.getItem(key);
			//			CommonUtils.consoleLog('db get key: ' + key + ' value: ' + val);
			return JSON.parse(val);
		}
	}

	ins.saveCaller = function(caller, data) {
		var key = JSON.stringify(caller);
		ins.add(key, data);
	}

	ins.getCaller = function(caller) {
		var key = JSON.stringify(caller);
		var val = ins.get(key);
		return val;
	}

	/**
	 * @description 删除一个对象，Key
	 */
	ins.del = function(key) {
		//		console.log('db del key: ' + key);
		if (w.plus)
			plus.storage.removeItem(key);
	}

	/**
	 * @description 清除所有数据
	 */
	ins.clearall = function() {
		console.log('db clearall');
		if (w.plus)
			plus.storage.clear();
	}

	/**
	 * @description 更新一个对象
	 */
	ins.update = function(key, value) {
		if (w.plus) {
			val = JSON.stringify(value);
			plus.storage.setItem(key, val);
			//			CommonUtils.consoleLog('db update key: ' + key + ' value: ' + val);
		}
	}

	return ins;

})(mui, window);

/**
 * @description 原生接口操作类
 */
var sg = (function(mui, w) {

	var ins = new mui.Class();
	ins.isNetWorkConnected = true;
	ins.currNeworkState = null;
	ins.appRun = true;
	ins.networkTypes = {
		0: "网络连接状态未知",
		1: "当前网络不可用，请检查网络设置。",
		2: "有线网络",
		3: "无线WIFI网络",
		4: "蜂窝移动2G网络",
		5: "蜂窝移动3G网络",
		6: "蜂窝移动4G网络"
	};

	ins.isOfflineModel = function(val) {
		if (typeof val === 'undefined') {
			return db.get('isOfflineModel');
		} else {
			db.add('isOfflineModel', val);
		}
	}

	/** google track */
	ins.SGTrackView = function(pageName) {
		if (w.plus && plus.pluginforck) {
			var caller = pageName || ins.getCallerName(arguments.callee);
			console.debug('SGTrackView ' + caller);
			plus.pluginforck.TrackView(caller);
		}
	}

	ins.SGTrackViewAction = function(action, pageName) {
		if (w.plus && plus.pluginforck) {
			var caller = pageName || ins.getCallerName(arguments.callee);
			console.debug('SGTrackViewAction ' + caller + ' ' + action);
			plus.pluginforck.TrackViewAction(caller, action);
		}
	}

	ins.getAppVersion = function() {
		if (w.plus) {
			return plus.runtime.version;
		} else {
			return APP_VERSION;
		}
	}

	ins.SGGetDeviceCode = function() {
		if (w.plus && plus.pluginforck) {
			return plus.pluginforck.GetDeviceCode();
		} else if (w.plus) {
			return plus.device.uuid;
		}
	}

	ins.SGIsNeedKickUser = function() {
		if (w.plus && plus.pluginforck) {
			return plus.pluginforck.IsNeedKickUser();
		} else if (w.plus) {
			return 'false';
		}
	}

	ins.SGShareContent = function(title, content) {
		if (w.plus && plus.pluginforck) {
			plus.pluginforck.ShareContent(title, content);
		} else {
			alert('Share content:: title=[' + title + '], content=[' + content + ']');
		}
	}

	ins.SGGetAgentLogo = function(agentId) {
		if (w.plus && plus.pluginforck) {
			return plus.pluginforck.GetAgentLogo(agentId);
		} else {
			return "../img/default_avatar.png";
		}
	}

	ins.SGOpenChatWithAgent = function(agentId, scenario, quoteDetail) {
		if (w.plus && plus.pluginforck) {
			return plus.pluginforck.OpenChatWithAgent(agentId, scenario, quoteDetail);
		} else {
			alert('chat with agent ' + agentId);
		}
	}

	ins.SGRateAppStore = function() {
		if (w.plus && plus.pluginforck) {
			return plus.pluginforck.RateAppStore();
		} else {
			alert('Rate at Store ');
		}
	}

	ins.SGRateGooglePlay = function() {
		if (w.plus && plus.pluginforck) {
			return plus.pluginforck.RateGooglePlay();
		} else {
			alert('Rate at Google Play ');
		}
	}

	/**
	 * document.getElementById(id)的封装
	 * @param {String} id
	 */
	ins.node = function(id) {
		var el = document.getElementById(id);
		if (el) {
			return el;
		} else {
			throw new Error('找不到这个id：' + id + '，位置：' + document.location.toString());
		}
	};

	/**
	 * 标签样式设为display:none
	 * @param {String} id
	 */
	ins.nodeHide = function(id) {
		ins.node(id).style.display = 'none';
	};

	/**
	 * 标签样式设为display:block
	 * @param {String} id
	 */
	ins.nodeShow = function(id) {
		ins.node(id).style.display = 'block';
	};

	/**
	 * 标签属性设为disabled:disabled
	 * @param {String} id
	 */
	ins.nodeDisable = function(id) {
		ins.node(id).setAttribute('disabled', 'disabled');
	};

	/**
	 * 标签移除disabled属性
	 * @param {String} id
	 */
	ins.nodeEnable = function(id) {
		ins.node(id).removeAttribute('disabled');
	};

	/**
	 * 根据html设置id标签的innerHTML
	 * @param {String} id（选择标签的id）
	 * @param {String} html（设置的html）
	 */
	ins.nodeHtml = function(id, html) {
		ins.node(id).innerHTML = html;
	};

	/**
	 * 根据html追加id标签的innerHTML
	 * @param {String} id（选择标签的id）
	 * @param {String} html（追加的html）
	 */
	ins.nodeAppendHtml = function(id, html) {
		ins.node(id).innerHTML += html;
	};

	/**
	 * 模板引擎渲染数据封装函数
	 * @param {String} id（选择标签的id）
	 * @param {String} tmpl（模板id）
	 * @param {Object} data（填充数据）
	 */
	ins.nodeTemplate = function(id, tmpl, data) {
		var appendHtml;
		if (typeof template == 'function' && data) {
			appendHtml = template(tmpl, data);
			ins.nodeHtml(id, appendHtml);
			return appendHtml;
		} else if (typeof template != 'function') {
			throw new Error('template.js未引入，位置：' + document.location.toString() + '');
		} else if (!data) {
			throw new Error('template需要的data为空，位置：' + document.location.toString() + '');
		}
	};

	/**
	 * 模板引擎追加数据封装函数
	 * @param {String} id（选择标签的id）
	 * @param {String} tmpl（模板id）
	 * @param {Object} data（追加的数据）
	 */
	ins.nodeAppendTmpl = function(id, tmpl, data) {
		var appendHtml;
		if (typeof template == 'function' && data) {
			appendHtml = template(tmpl, data);
			ins.nodeAppendHtml(id, appendHtml);
			return ins.node(id).innerHTML;
		} else if (typeof template != 'function') {
			throw new Error('template.js未引入，位置：' + document.location.toString() + '');
		} else if (!data) {
			throw new Error('template需要的data为空，位置：' + document.location.toString() + '');
		}
	};

	/**
	 * @description 获到系统类型，1：web, 2：ios，3：android
	 */
	ins.AppSystem = function() {
		if (mui.os.ios)
			return 2;
		else if (mui.os.android)
			return 3;
		else
			return 1;
	};

	ins.pushRestart = function() {
		if (w.plus)
			plus.runtime.restart();
	}

	/**
	 * @description 发出蜂鸣声
	 */
	ins.pushBeep = function(num) {
		if (w.plus)
			plus.device.beep(num);
	}

	/**
	 * @description 设备振动
	 */
	ins.pushVibrate = function(milliseconds) {
		if (w.plus)
			plus.device.vibrate(milliseconds); //默认为500ms
	}

	ins.showWaiting = function(txt) {
		var tmptxt = txt || "";
		if (w.plus)
			return plus.nativeUI.showWaiting(tmptxt);
		return null;
	}

	ins.hideWaiting = function() {
		if (w.plus)
			plus.nativeUI.closeWaiting();
	}

	/**
	 * @description 屏幕常亮
	 */
	ins.pushWakelock = function(lock) {
		if (w.plus)
			plus.device.setWakelock(lock); //可取值ture或false，true表示设定程序一直保持唤醒状态，false表示关闭程序一直保持唤醒状态。程序退出后将恢复默认状态，默认为关闭程序保持唤醒状态。
	}

	/** @description 获取程序是否一直保持唤醒（屏幕常亮）状态 */
	ins.isWakelock = function() {
		if (w.plus)
			return plus.device.isWakelock();
	}

	/**
	 * @description 锁定屏幕方向
	 * "portrait-primary": 竖屏正方向；
	 * "portrait-secondary": 竖屏反方向，屏幕正方向按顺时针旋转180°；
	 * "landscape-primary": 横屏正方向，屏幕正方向按顺时针旋转90°；
	 * "landscape-secondary": 横屏方向，屏幕正方向按顺时针旋转270°；
	 * "portrait": 竖屏正方向或反方向，根据设备重力感应器自动调整；
	 * "landscape": 横屏正方向或反方向，根据设备重力感应器自动调整
	 */
	ins.pushLockOrientation = function(orientation) {
		if (w.plus)
			plus.screen.lockOrientation(orientation);
	}

	/** @description 解除锁定屏幕方向 */
	ins.pushUnlockOrientation = function() {
		if (w.plus)
			plus.screen.unlockOrientation();
	}

	/** @description 当前应用ID */
	ins.getAppId = function() {
		if (w.plus)
			return plus.runtime.appid;
	}

	/** @description 当前设备UUID */
	ins.getDeviceUUID = function() {
		return ins.SGGetDeviceCode();
	}

	/** @description 激活到前台 */
	ins.onAppReume = function() {
		ins.appRun = true;
		//sg.log( "Application resumed!" ); 
	}

	/** @description 放到后台 */
	ins.onAppPause = function() {
			ins.appRun = false;
			//sg.log( "Application paused!" ); 
		}
		/**
		 * @description 设置网络状态（网络变更时自动调用）
		 */
	ins.setNetworkState = function() {
			var nwStr = ins.networkTypes[ins.currNeworkState];
			//sg.debug("NetworkStateChanged: "+nwStr);
			switch (ins.currNeworkState) {
				case 2: //plus.networkinfo.CONNECTION_ETHERNET:
				case 3: //plus.networkinfo.CONNECTION_WIFI:
					ins.isNetWorkConnected = true;
					//alert("Switch to Wifi networks!"); 
					break;
				case 4: //plus.networkinfo.CONNECTION_CELL2G:
				case 5: //plus.networkinfo.CONNECTION_CELL3G:
				case 6: //plus.networkinfo.CONNECTION_CELL4G:
					ins.isNetWorkConnected = true;
					//alert("Switch to Cellular networks!");  
					break;
				default:
					ins.isNetWorkConnected = false;
					//alert("Not networks!"); 
					break;
			}

		}
		/**
		 * @description 网络切换
		 * CONNECTION_UNKNOW: 网络连接状态未知
		 * CONNECTION_NONE: 未连接网络
		 * CONNECTION_ETHERNET: 有线网络
		 * CONNECTION_WIFI: 无线WIFI网络
		 * CONNECTION_CELL2G: 蜂窝移动2G网络
		 * CONNECTION_CELL3G: 蜂窝移动3G网络
		 * CONNECTION_CELL4G: 蜂窝移动4G网络
		 */
	ins.onNetChange = function() {
		if (w.plus) {
			ins.currNeworkState = plus.networkinfo.getCurrentType(); //plus.networkinfo.getCurrentType();
			ins.setNetworkState();
		}
	}

	/** @description 存文件日志 */
	ins.saveLog = function(txt) {
		//console.warn(txt);
		if (w.plus && plus.pluginforck) {
			plus.pluginforck.WriteLog(txt + '\n');
		} else if (w.plus) {
			plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function(fs) {
				// fs.root是根目录操作对象DirectoryEntry
				fs.root.getFile('shenguyun.log', {
					create: true
				}, function(fileEntry) {
					fileEntry.createWriter(function(fileWriter) {
						// fast forwards file pointer to end of file
						fileWriter.onerror = function(e) {
							sg.debug("fileWriter.onerror: " + e.message);
						}
						if (fileWriter.length > 0)
							fileWriter.seek(fileWriter.length - 1);
						var d = new Date;
						fileWriter.write(d + txt);
					}, function(e) {
						alert(e.message);
					});
				});
			}, function(e) {
				alert("Resolve file URL failed: " + e.message);
			});
		}
	}

	ins.getCurrPage = function() {
		var p = document.location.toString();
		if (p) {

			var strList = p.split('/');
			var len = strList.length;
			if (len > 0)
				return strList[len - 1];
		}
		return p;
	};

	ins.getCallerName = function(caller, level) {
		try {
			if (!caller)
				return '';
			if (!level)
				level = 1;
			if (level > 5)
				return '';
			if (!caller.name || caller.name == '')
				return ins.getCallerName(caller.caller, level + 1);
			return ' at ' + ins.getCurrPage() + '::' + caller.name + '().';
		} catch (e) {
			return ins.getCurrPage();
		}

	}

	ins.error = function(txt) {
		var caller = ins.getCallerName(arguments.callee);
		console.error(txt + caller);
		ins.saveLog(' [error] ' + txt + caller);
	}

	ins.warn = function(txt) {
		var caller = ins.getCallerName(arguments.callee);
		console.warn(txt + caller);
		ins.saveLog(' [warn] ' + txt + caller);
	}

	ins.log = function(txt) {
		var caller = ins.getCallerName(arguments.callee);
		console.log(txt + caller);
		ins.saveLog(' [log] ' + txt + caller);
	}

	ins.debug = function(txt) {
		var caller = ins.getCallerName(arguments.callee);
		console.debug(txt + " ==== " + caller);
		ins.saveLog(' [debug] ' + txt + caller);
	}

	/** @description 设置应用Icon提示数字 */
	ins.setBadgeNumber = function(num) {
		if (w.plus)
			plus.runtime.setBadgeNumber(num);
	}

	/** @description 关闭启动图片*/
	ins.closeSplashscreen = function() {
		if (w.plus && plus.pluginforck) {
			plus.pluginforck.CloseLoading();
		} else if (w.plus) {
			plus.navigator.closeSplashscreen();
		}
	}

	/** @description 显示自动隐藏的提示（系统） */
	ins.showToast = function(txt) {
		if (w.plus)
			plus.ui.toast(txt, {
				duration: "short",
				verticalAlign: "center"
			});
	}

	/** @description 取首页的WebView*/
	ins.getRootWebView = function() {
		if (w.plus)
			plus.webview.getWebviewById(ins.getAppId());
	}

	/** @description 获取网络状态的文字*/
	ins.getNetworkConnStr = function() {
		return ins.networkTypes[ins.currNeworkState];
	}

	/**
	 * document.getElementById(id).addEventListener('tap', function)的封装
	 * @param {String} id
	 * @param {Function} callback
	 */
	ins.addTapEventListener = function(id, callback) {
		ins.node(id).addEventListener('tap', function(e) {
			var target = e.target;
			if (target.disabled) {
				return;
			}
			callback.call(this, e);
		});
	};

	ins.isLoading = function(boxId) {
		var isShow = document.getElementById('pullrefresh').style.display == '' && document.getElementById('loadMsg').innerText == 'loading...';
		return isShow;
	}
	ins.showLoading = function(boxId) {
		boxId = boxId || 'dataBox';
		ins.nodeHide(boxId);
		ins.nodeShow('pullrefresh');
		var divIcon = document.getElementById('loadIcon');
		divIcon.classList.remove('mui-icon-loop');
		divIcon.classList.remove('mui-icon-info');
		divIcon.classList.remove('mui-spinner');
		divIcon.classList.add('mui-spinner');
		document.getElementById('loadMsg').innerText = 'loading...';
	}
	ins.showReLoad = function(boxId) {
		boxId = boxId || 'dataBox';
		ins.nodeHide(boxId);
		ins.nodeShow('pullrefresh');
		var divIcon = document.getElementById('loadIcon');
		divIcon.classList.remove('mui-icon-loop');
		divIcon.classList.remove('mui-icon-info');
		divIcon.classList.remove('mui-spinner');
		divIcon.classList.add('mui-icon-loop');
		document.getElementById('loadMsg').innerText = 'tap to reload...';
	}
	ins.showDataBox = function(boxId) {
		boxId = boxId || 'dataBox';
		ins.nodeHide('pullrefresh');
		ins.nodeShow(boxId);
		var divIcon = document.getElementById('loadIcon');
		divIcon.classList.remove('mui-icon-loop');
		divIcon.classList.remove('mui-icon-info');
		divIcon.classList.remove('mui-spinner');
		divIcon.classList.add('mui-spinner');
		document.getElementById('loadMsg').innerText = 'loading...';
	}

	ins.showNoData = function(txt, boxId) {
		txt = txt || 'no data';
		boxId = boxId || 'dataBox';
		ins.nodeHide(boxId);
		ins.nodeShow('pullrefresh');
		var divIcon = document.getElementById('loadIcon');
		divIcon.classList.remove('mui-icon-loop');
		divIcon.classList.remove('mui-icon-info');
		divIcon.classList.remove('mui-spinner');
		divIcon.classList.add('mui-icon-info');
		document.getElementById('loadMsg').innerText = txt;
	}

	/** @description 获取以数字编号的网络状态： 
	 * 1：有线和WIFI，
	 * 2：3G和4G，
	 * 3：2G，
	 * 4：无网络
	 */
	ins.getNetworkState3 = function() {
		//sg.debug("NetworkStateChanged: "+nwStr);
		switch (ins.currNeworkState) {
			case 2: //plus.networkinfo.CONNECTION_ETHERNET:
			case 3: //plus.networkinfo.CONNECTION_WIFI:
				return 1;
				//alert("Switch to Wifi networks!"); 
				break;
			case 4: //plus.networkinfo.CONNECTION_CELL2G:
				return 3;
			case 5: //plus.networkinfo.CONNECTION_CELL3G:
			case 6: //plus.networkinfo.CONNECTION_CELL4G:
				return 2;
				//alert("Switch to Cellular networks!");  
				break;
			default: //none
				return 4;
				//alert("Not networks!"); 
				break;
		}
	}

	ins.showNetworkError = function() {

		var nwState = sg.getNetworkState3();
		switch (nwState) {
			case 1:
			case 2:
				sg.showToast("Network request timed out, try again later.");
				sg.error("数据请求超时。请重试！");
				break;
			case 3:
				sg.showToast("Network request timed out, Please check your internet connection and try again.");
				sg.error("数据请求超时。请检查2G网络是否稳定！");
				break;
			case 4:
				sg.showToast("Network Unavailable, Please check your internet connection.");
				sg.error("数据请求超时。请连接网络！");
				break;
		}
	}

	ins.screenLockV = function() {
		plus.screen.lockOrientation("portrait-primary");
	}

	ins.screenLockH = function() {
			plus.screen.lockOrientation("landscape-primary");
		}
		

	/**
	 * 增加排队信息
	 * @param {Object} quene（排队信息）
	 */

	ins.pushQueneInfo = function(key, content) {
		var quene = sg.getQueneInfo(key);
		if (!quene) {
			quene = [];
		}
		quene.unshift(content);
		db.add(key, quene);
	}

	
	ins.curr_screen = "portrait-primary";

	/**
	 * 版本升级接口
	 */
	ins.checkUpdate = function() {
		var appVer = null;
		// 获取本地应用资源版本号
		plus.runtime.getProperty(plus.runtime.appid, function(inf) {
			appVer = inf.version;
			// 检测更新URL
			var checkUrl = interfaceHost + "/i/upgrade/version.txt";
			console.log(checkUrl);
			mui.getJSON(checkUrl, null, function(data, status, xhr) {
				console.log('升级中...');
				console.log("当前应用版本：[" + appVer + ']');
				console.log("服务器是否允许更新：[" + data.enable + ']');
				console.log("服务器最新版本：[" + data.version + ']');
				console.log("服务器更新说明：[" + data.releaseNote + ']');
				console.log("更新文件名：[" + data.fileName + ']');
				if (appVer && data.version && data.enable && (appVer < data.version)) {
					sg.showToast('检测到更新，后台下载中');
					// 下载升级包
					ins.downWgt((data.fileName || 'latest.wgt'));
				}
			});
		});
	};

	ins.downWgt = function(fileName) {
		// 下载wgt文件
		var wgtUrl = interfaceHost + "/i/upgrade/" + fileName;
		plus.downloader.createDownload(wgtUrl, {
			filename: "_doc/update/"
		}, function(d, status) {
			if (status == 200) {
				console.log("下载更新文件成功：" + d.filename);
				ins.installWgt(d.filename); // 安装wgt包
			} else {
				console.log("下载更新文件失败！");
			}
		}).start();
	}

	ins.installWgt = function(path) {
		plus.runtime.install(path, {}, function() {
			console.log("安装更新文件成功！");
			plus.nativeUI.alert("新版本已经下载并更新成功！重启完成安装！", function() {
				plus.runtime.restart();
			});
		}, function(e) {
			console.log("安装更新文件失败[" + e.code + "]：" + e.message);
		});
	}

	//Ready
	function sgReady() {
		//plus.screen.lockOrientation(ins.screenModel);
		document.addEventListener("netchange", ins.onNetChange);
		document.addEventListener("pause", ins.onAppPause);
		document.addEventListener("resume", ins.onAppReume);

		ins.currNeworkState = plus.networkinfo.getCurrentType();
		ins.setNetworkState();
		//plus.screen.lockOrientation(ins.curr_screen);
		//关闭所有滚动条
		plus.webview.currentWebview().setStyle({
			'scrollIndicator': 'none'
		});
	}

	if (w.plus) {
		sgReady();
	} else {
		document.addEventListener('plusready', sgReady);
	}

	return ins;

})(mui, window);

/**
 * @description MUI工具类
 */
var MUIUtils = (function(mui, w) {

	var ins = new mui.Class();

	return ins;

})(mui, window);

/**
 * @description 通用工具类，有公用函数往这里加
 */
var CommonUtils = {
	clickCount: 0,
	checkDoubleClick: function() {
		var _ = this;
		++_.clickCount;
		if (_.clickCount > 1) {
			console.debug('double click, ignore this click');
			return false;
		}

		setTimeout(function() {
			_.clickCount = 0;
		}, 500);
		return true;
	},
	vailMobile: function(val) {
		var pattern = /(^0{0,1}1[3|4|5|6|7|8|9][0-9]{9}$)/;
		if (pattern.test(val)) {
			return true;
		} else {
			return false;
		}
	},

	verifyName: function(name) {
		var regExStr = /\u4E00-\u9FA5/;
		var result = regExStr.test(name);
		if (!result) {
			return false;
		}
		return true;
	},
	verifyEmail: function(email) {
		if (email.length == 0) {
			sg.showToast('Please input Email.');
			return false;
		}
		var regExStr = /^[_a-zA-Z0-9\-]+(\.[_a-zA-Z0-9\-]*)*@[a-zA-Z0-9\-]+([\.][a-zA-Z0-9\-]+)+$/;
		var result = regExStr.test(email);
		if (!result) {
			return false;
		}
		return true;
	},
	//阻止事件冒泡
	stopBubble: function() {
		var evt = window.event;
		evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
		evt.preventDefault();
	},

	consoleLog: function(text) {
		if (text && text.length > 1000) {
			console.log(text.substr(0, 1000));
		} else {
			console.log(text);
		}
	},
	setCursorPos2End: function(id) {
		setTimeout(function() {
			sg.node(id).setSelectionRange(900, 1000);
		}, 10);
	},
	onFocusInput: function(id) {
		var _ = this;
		_.setCursorPos2End(id);
	},
	popCenter: function(popId) {
		var tmpMenuPopover = document.getElementById(popId);
		var winWidth = document.body.clientWidth;
		var winHeight = document.body.clientHeight;

		if (window.plus) {
			winWidth = window.plus.screen.resolutionWidth;
			winHeight = window.plus.screen.resolutionHeight - 44;
		}
		var popWidth = tmpMenuPopover.clientWidth;
		var popHeight = tmpMenuPopover.clientHeight;
		var offsetY = parseInt((winHeight - popHeight) / 2);
		var offsetX = parseInt((winWidth - popWidth) / 2);

		tmpMenuPopover.style.top = offsetY + 'px';
		tmpMenuPopover.style.bottom = offsetY + 'px';
		tmpMenuPopover.style.left = offsetX + 'px';
		tmpMenuPopover.style.right = offsetX + 'px';
	},
	closePopover: function(id) {
		var pop = document.getElementById(id);
		if (pop && pop.classList.contains('mui-active')) {
			sg.debug("Hide popover!" + id);
			mui('#' + id).popover("toggle");
			return true;
		}
		return false;
	},
	//  formId 为表单 父元素
	//.form-item 为表单子元素
	// 规定 -- >  若不为input，则自定义表情均设置 form-name 和 form-value 否则无法获取 
	getFormData: function(formId) {
		var form = document.getElementById(formId);
		if (!form) {
			throw new Error('自定义form的id不存在：' + formId);
		} else {
			var dataEls = form.querySelectorAll('.form-item');
			var para = {};
			for (var i = 0; i < dataEls.length; i++) {
				var tag = dataEls[i];
				if (tag.tagName == 'INPUT') { //input标签取name和value
					para[tag.name] = tag.value;
				} else { //其他标签取form-name和form-value
					var form_name = tag.getAttribute('form-name');
					var form_value = tag.getAttribute('form-value');
					if (!form_name) {
						throw new Error('自定义form中：' + tag.outerHTML + '，未设置form-name属性');
					}
					if (!form_value) {
						if (typeof form_value !== 'string') {
							throw new Error('自定义form中：' + tag.outerHTML + '，未设置form-value属性');
						}
					}
					para[form_name] = form_value;
				}
			}
			return para;
		}
	}

};
/**
 * 图片轮播初始化控件
 */
var ImageSlider = {
	/**
	 * 根据传入的参数数组递归取图片值
	 * @param {Object} obj 数据对象参数
	 * @param {Array} prpt 数据对象里的图片递归位置
	 */
	getImage: function(obj, prpt) {
		if (prpt && Array.isArray(prpt)) {
			var currentPrpt = prpt.shift(); //抛出数组的第一个元素，这个方法会改变原数组
			if (prpt.length) { //未达到最底层，递归执行
				return this.getImage(obj[currentPrpt], prpt); //递归查找图片
			} else {
				return obj[currentPrpt]; //到达图片所在位置，返回
			}
		} else {
			console.error('轮播初始化失败：传入图片递归参数不是一个数组');
		}
	},
	/**
	 * 初始化轮播图
	 * 调用格式如：ImageSlider.init('slider', data, ['detail', 'info', 'image']);
	 * @param {String} id 轮播图的盒子id
	 * @param {Array} data 数据数组
	 * @param {Array} property 数据对象里的图片递归位置
	 *  @param {Array} ary 数据对象里的图片ary递归位置
	 */
	init: function(id, data, property, ary) {
		var _ = this;
		var wrapper = document.getElementById(id);
		if (data && Array.isArray(data)) {
			var appendHtml = '<div class="mui-slider"><div class="mui-slider-group mui-slider-loop">';
			var dataLength = data.length;
			//数据数组首尾
			data = data.slice(-1).concat(data); //数据列表构造：X123...X
			data.push(data[1]); //数据列表构造：X123...X1
			//构造轮播的图片
			data.forEach(function(item, index) {
				var img = _.getImage(item, property.concat()); //这个函数会改变引用的数组，所以需要传进对象的复制
				var imgId = "";
				if (ary != undefined)
					imgId = _.getImage(item, ary.concat()); //这个函数会改变引用的数组，所以需要传进对象的复制
				if (index == 0 || index == dataLength - 1) { //为了循环轮播，首尾需要特殊处理
					appendHtml += '<div class="mui-slider-item mui-slider-item-duplicate" data-id=' + imgId + '><a href="javascript:void(0)"><img' + onErrorImg + ' src="' + img + '"></a></div>';
				} else {
					appendHtml += '<div class="mui-slider-item" data-id=' + imgId + '><a href="javascript:void(0)"><img' + onErrorImg + ' src="' + img + '"></a></div>';
				}
			});
			//构造轮播的指示器
			appendHtml += '</div><div class="mui-slider-indicator"><div class="mui-indicator mui-active"></div>';
			for (var i = 0; i < dataLength - 1; i++) {
				appendHtml += '<div class="mui-indicator"></div>';
			}
			appendHtml += '</div></div>';
			wrapper.innerHTML = appendHtml;
			mui("#" + id).slider({ //手动初始化轮播插件
				interval: 3000 //自动轮播周期，若为0则不自动播放，默认为0；
			});
		} else {
			console.error('轮播初始化失败：传入数据参数不是一个数组');
		}
	}
};

