;
(function($, document, config) {
	"use strict";
	var project = {
		init: function() {
			var _ = this;
			_.bindEvent();
		},
		bindEvent: function() {
			var myreg = /^[1][3578][0-9]{9}$/;
			//点击下一步按钮
			sg.node('submmit').addEventListener('tap', function() {
				if(sg.node('phone').value.length != 11 || !(myreg.test(sg.node('phone').value))) {
					plus.nativeUI.toast('请输入正确的手机号码');
					return;
				} else {
					sg.showWaiting('验证中...');
					httpClient.get(interfaceHost + "sendPathca.do?phone=" + sg.node('phone').value, function(data) {
						if(data.status) {
							mui.openWindow({
								url: '../../html/login/getPatchca.html',
								id: 'getPatchca.html',
								extras: {
									phone: sg.node('phone').value //扩展参数
								},
								waiting: {
								autoShow: false
							}
							});
						}
						sg.hideWaiting();
						mui.toast(data.message);
					}, function(error) {
						sg.hideWaiting();
					});
				}
			}, false);
		}
	};
	mui.init({});
	mui.plusReady(function() {
		project.init();
	});
})(mui, document, {});