(function($, document, config) {
	"use strict";
	var messageId;
	var project = {
		init: function() {
			var _ = this;
			_.bindEvent();
		},
		bindEvent: function() {
			var self = plus.webview.currentWebview();
			messageId = self.messageId;
			sg.showWaiting('加载中...');
			httpClient.get(interfaceHost + "messageDetail.do", {
				messageId: messageId
			}, function(data) {
				sg.hideWaiting();
				sg.node('messageDetail').innerHTML = data.messageDetail,
				sg.node('messageTime').innerText = data.createTimeStr
				if(data.update) {
					var mainView = plus.webview.getWebviewById('main.html');
					var messageView = plus.webview.getWebviewById('message.html');
					mui.fire(messageView, 'refreshMessage');
					mui.fire(mainView, 'refreshMessage');
				}
			}, function(error) {
				sg.hideWaiting();
				//mui.toast("网络异常");
			});

		}
	};
	mui.init({});
	mui.plusReady(function() {
		project.init();
	});

})(mui, document, {});