(function($, document, config) {
	"use strict";
	var project = {
		init: function() {
			var _ = this;
			_.bindEvent();
		},
		bindEvent: function() {
			var userName = plus.webview.currentWebview().userName;
			sg.node('userName').value = userName;
			sg.node('submit').addEventListener('tap', function() {
				if(sg.node('userName').value==null || sg.node('userName').value == '') {
					mui.toast('请输入姓名');
					return;
				} else {
					sg.showWaiting('保存中...');
					httpClient.post(interfaceHost+"updateUserInfo.do",{
						token:db.get('userToken'),
						userName:sg.node('userName').value
					},function(data){
						if(data.status){//保存成功
							var userView = plus.webview.getWebviewById('personal_profile.html');
							var mainView = plus.webview.getWebviewById('mine/tab-mine.html');
							mui.fire(userView, 'refurbish');
							mui.fire(mainView, 'refurbish');
						}
						mui.toast(data.message);
						sg.hideWaiting();
					},function(error){
						if (error.toString().indexOf('timeout')) {
						sg.showToast('请求超时！');
					}
					sg.hideWaiting();
					});
				}
			}, false);
		}
	};
	mui.init({});
	mui.plusReady(function() {
		project.init();
	});
})(mui, document, {});